<?php

namespace Fazed\NyaaRssParser\Models;

use Fazed\NyaaRssParser\Contracts\Models\EntryContract;

class Entry extends DataModel implements EntryContract
{
    /**
     * @var string
     */
    protected $title;

    /**
     * @var string
     */
    protected $description;

    /**
     * @var string
     */
    protected $link;

    /**
     * @var string
     */
    protected $guid;

    /**
     * @var string
     */
    protected $pubDate;

    /**
     * @var int
     */
    protected $seeders;

    /**
     * @var int
     */
    protected $leechers;

    /**
     * @var int
     */
    protected $downloads;

    /**
     * @var string
     */
    protected $infoHash;

    /**
     * @var string
     */
    protected $categoryId;

    /**
     * @var string
     */
    protected $category;

    /**
     * @var string
     */
    protected $size;

    /**
     * Entry constructor.
     *
     * @param array $properties
     */
    public function __construct(array $properties = [])
    {
        parent::__construct($properties);
    }

    /**
     * {@inheritdoc}
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * {@inheritdoc}
     */
    public function setTitle($title)
    {
        $this->title = $title;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * {@inheritdoc}
     */
    public function setDescription($description)
    {
        $this->description = $description;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getLink()
    {
        return $this->link;
    }

    /**
     * {@inheritdoc}
     */
    public function setLink($link)
    {
        $this->link = $link;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getGuid()
    {
        return $this->guid;
    }

    /**
     * {@inheritdoc}
     */
    public function setGuid($guid)
    {
        $this->guid = $guid;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getPubDate()
    {
        return $this->pubDate;
    }

    /**
     * {@inheritdoc}
     */
    public function setPubDate($pubDate)
    {
        $this->pubDate = $pubDate;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getSeeders()
    {
        return $this->seeders;
    }

    /**
     * {@inheritdoc}
     */
    public function setSeeders($seeders)
    {
        $this->seeders = $seeders;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getLeechers()
    {
        return $this->leechers;
    }

    /**
     * {@inheritdoc}
     */
    public function setLeechers($leechers)
    {
        $this->leechers = $leechers;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getDownloads()
    {
        return $this->downloads;
    }

    /**
     * {@inheritdoc}
     */
    public function setDownloads($downloads)
    {
        $this->downloads = $downloads;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getInfoHash()
    {
        return $this->infoHash;
    }

    /**
     * {@inheritdoc}
     */
    public function setInfoHash($infoHash)
    {
        $this->infoHash = $infoHash;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getCategoryId()
    {
        return $this->categoryId;
    }

    /**
     * {@inheritdoc}
     */
    public function setCategoryId($categoryId)
    {
        $this->categoryId = $categoryId;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getCategory()
    {
        return $this->category;
    }

    /**
     * {@inheritdoc}
     */
    public function setCategory($category)
    {
        $this->category = $category;

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function getSize()
    {
        return $this->size;
    }

    /**
     * {@inheritdoc}
     */
    public function setSize($size)
    {
        $this->size = $size;

        return $this;
    }
}
